<?php

/*
+----------------------------------------------------------------+
+	imageRotartor-XML V1.10
+	by Alex Rabe
+   	required for NextGEN Gallery
+----------------------------------------------------------------+
*/

$wpconfig = realpath("../../../wp-config.php");
if (!file_exists($wpconfig)) die; // stop when wp-config is not there

require_once($wpconfig);

function get_out_now() { exit; }
add_action('shutdown', 'get_out_now', -1);

global $wpdb;
$ngg_options = get_option('ngg_options');

// get the gallery id
$galleryID = (int) attribute_escape($_GET['gid']);

// get the pictures
if ($galleryID == 0) {
	$thepictures = $wpdb->get_results("SELECT * FROM $wpdb->nggpictures WHERE exclude != 1 ORDER BY $ngg_options[galSort] $ngg_options[galSortDir]");	
} else {
	$act_gallery = $wpdb->get_row("SELECT * FROM $wpdb->nggallery WHERE gid = '$galleryID' ");
	$thepictures = $wpdb->get_results("SELECT * FROM $wpdb->nggpictures WHERE galleryid = '$galleryID' AND exclude != 1 ORDER BY $ngg_options[galSort] $ngg_options[galSortDir]");
}
// set gallery url
$folder_url 	= get_option ('siteurl')."/".$act_gallery->path."/";

// Create XML output
header("content-type:text/xml;charset=utf-8");

echo "<playlist version='1' xmlns='http://xspf.org/ns/0/'>\n";
echo "	<title>".$act_gallery->name."</title>\n";
echo "	<trackList>\n";

if (is_array ($thepictures)){
	foreach ($thepictures as $picture) {
		echo "		<track>\n";
		if (!empty($picture->description))	
		echo "			<title>".strip_tags($picture->description)."</title>\n";
		else if (!empty($picture->alttext))	
		echo "			<title>".$picture->alttext."</title>\n";
		else 
		echo "			<title>".$picture->filename."</title>\n";
		echo "			<location>".$folder_url.$picture->filename."</location>\n";
		echo "		</track>\n";
	}
}
 
echo "	</trackList>\n";
echo "</playlist>\n";

?>